% load the data file for each testing case
% output is the BLER, Total UEs and Dropped UEs, 
% the served UE number can be found by total UEs - Dropped UEs

function [result,fileidx] = res_bler_NoUEOUT(test_resource_allocation_idx,UE,LARArate,MIMO,loaddir,result,fileidx,Comm_conf,figdir)
filename = ['RA',num2str(test_resource_allocation_idx),'_UE',num2str(UE),'_LARA',num2str(LARArate),MIMO,'_trms',num2str(Comm_conf.t_rms),'f',num2str(Comm_conf.fd),'_s',num2str(Comm_conf.state),'N',num2str(Comm_conf.N),'subN',num2str(Comm_conf.subN),'_E',num2str(Comm_conf.flg_csi_err),'c',num2str(Comm_conf.flg_offset),'D',num2str(Comm_conf.DELAY),'BO',num2str(Comm_conf.BO_dB),'HPA',num2str(Comm_conf.use_HPA_flg),'_BLER',num2str(Comm_conf.targetFER),'.mat'];
load([loaddir,'/',filename],'save_outageCnt','save_user_mobID','save_bs_FrminErr','save_bs_mod');
fileidx = fileidx + 1
result.bler(fileidx)=sum(sum(save_bs_FrminErr))/sum(sum(save_bs_mod~=0));
result.userPersecond(fileidx) = double(max(max(save_user_mobID)))/(double(size(save_user_mobID,2))*5e-4);
result.outagePersecond(fileidx) = double(save_outageCnt)/(size(save_user_mobID,2)*5e-4);
%%%%%%%%%%%%%%%%%%%%%% added by suvra to build figures %%%%%%%%%%%%%%%%%%%%
lgd = {'PF2,UE4,F1,SISO'};
y1 = result.userPersecond-result.outagePersecond;
y2 = result.outagePersecond;
result.bler
%%
y = [y1;y2];
handfig = cfigure(1);
bar(y);
handLGD = legend(lgd);
set(handLGD,'location','northeast','FontSize',14,'Box','on','fontname','times','FontWeight','normal');
colors = [0.5 0.5 0.5;0 0 0;0 0.5 1;0 0 1;1 0 0.5;1 0 0];
colormap(colors);
set(gca,'XTick',[])
xlabel('Different Schemes','FontSize',14,'fontname','times','FontWeight','b');
ylabel('No. of UEs per Second','FontSize',14,'fontname','times','FontWeight','b');
title('Served UEs             Dropped UEs','FontSize',15,'fontname','times','FontWeight','b');
annotation(handfig,'line',[0.5 0.5],[0.915 0.11],'LineWidth',2);
grid on
y3 = result.bler
%savefigs('nu_UEs',figdir);

savefigs('nu_UEs',[loaddir figdir]);
close(handfig)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%end of code added by suvra%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%s
