% CDF of instantaneous cell throughput
% calculated by B * R * * 6 * 12 (~Err) / T;
function [result,fileidx] = res_cdf_instTP(test_resource_allocation_idx,UE,LARArate,MIMO,loaddir,result,fileidx,av_factor,Comm_conf,figdir)
filename = ['RA',num2str(test_resource_allocation_idx),'_UE',num2str(UE),'_LARA',num2str(LARArate),MIMO,'_trms',num2str(Comm_conf.t_rms),'f',num2str(Comm_conf.fd),'_s',num2str(Comm_conf.state),'N',num2str(Comm_conf.N),'subN',num2str(Comm_conf.subN),'_E',num2str(Comm_conf.flg_csi_err),'c',num2str(Comm_conf.flg_offset),'D',num2str(Comm_conf.DELAY),'BO',num2str(Comm_conf.BO_dB),'HPA',num2str(Comm_conf.use_HPA_flg),'_BLER',num2str(Comm_conf.targetFER),'.mat'];
load([loaddir,'/',filename],'save_bs_mod','save_bs_fec','save_bs_FrminErr');
colors = {[0.5 0.5 0.5],[0 0 0],[0 0.5 1],[0 0 1],[1 0 0.5],[1 0 0]};
lst = {'-','-.','-','-.','-','-.'};
RAs = {'RR','PF','MX','PF2'};
para.RA = RAs{test_resource_allocation_idx};
UEs = [4 10];
para.UE = UE;
para.ra_ix = test_resource_allocation_idx;
if LARArate == 2,
    para.ra_ix = 4;
end
if MIMO == 2,
    para.ra_ix = 5;
end
para.ue_ix = find(UEs == para.UE);
para.nuSymbol = 6;
para.subN = 12;
para.Tfrm = 5e-4;

save_bs_instTP = 1e-6 * sum(double(save_bs_mod) .* save_bs_fec .* double(~save_bs_FrminErr),1) * para.nuSymbol * para.subN / 5e-4;
mns = sprintf('%3.2f',mean(save_bs_instTP));
fileidx = fileidx + 1;
%%
result.ra_idx(fileidx) = test_resource_allocation_idx;
result.LGD{fileidx} = [para.RA,',UE',num2str(para.UE),',F',num2str(LARArate),',',MIMO];
result.LGDmn{fileidx} = [para.RA,',UE',num2str(para.UE),',F',num2str(LARArate),',',MIMO,',M:',mns];
%%
cfigure%cfigure;
handCDF = cdfplot(save_bs_instTP);hold on;
set(handCDF,'color',colors{fileidx},'linestyle',lst{fileidx},'linewidth',2);
result.figname='CDF_of_bs_instTP';
xlabel('Instantaneous Cell Throughput in Mbps','FontSize',14,'fontname','times','FontWeight','b');
ylabel('CDF of Instantaneous Cell Throughput','FontSize',14,'fontname','times','FontWeight','b');
savefigs(result.figname,[loaddir figdir]);
close all