% CDF of UE throughput
% for each UE, find the total transmitted bits. divided by its alive time
function [result,fileidx] = res_cdf_of_uetp(test_resource_allocation_idx,UE,LARArate,MIMO,loaddir,result,fileidx,Comm_conf,figdir)
para.nuSymbol = 6;
para.subN = 12;
para.Tfrm = 5e-4;
filename = ['RA',num2str(test_resource_allocation_idx),'_UE',num2str(UE),'_LARA',num2str(LARArate),MIMO,'_trms',num2str(Comm_conf.t_rms),'f',num2str(Comm_conf.fd),'_s',num2str(Comm_conf.state),'N',num2str(Comm_conf.N),'subN',num2str(Comm_conf.subN),'_E',num2str(Comm_conf.flg_csi_err),'c',num2str(Comm_conf.flg_offset),'D',num2str(Comm_conf.DELAY),'BO',num2str(Comm_conf.BO_dB),'HPA',num2str(Comm_conf.use_HPA_flg),'_BLER',num2str(Comm_conf.targetFER),'.mat'];
load([loaddir,'/',filename],'save_user_mobID','save_bs_mobID','save_bs_mod','save_bs_fec','save_bs_FrminErr');
bs_data = double(save_bs_mod) .* save_bs_fec .* ~(save_bs_FrminErr) * para.nuSymbol * para.subN;
bs_mobID = reshape(save_bs_mobID,[],1);
bs_data = reshape(bs_data,[],1);
for lp_mob = 1:max(save_bs_mobID(:,end))
    if(mod(lp_mob,5) == 0),
        double(lp_mob) / double(max(save_bs_mobID(:,end))) * 100
    end
    data(lp_mob) = sum(bs_data(bs_mobID == lp_mob));
    tmp1 = save_user_mobID == lp_mob;
    idx1 = find(sum(tmp1,1) == 1);
    idx2 = find(sum(tmp1,2) ~= 0);
    lens(lp_mob) = length(idx1);
end
thpt = 1e-6 * data ./ lens / 5e-4;
colors = {[0.5 0.5 0.5],[0 0 0],[0 0.5 1],[0 0 1],[1 0 0.5],[1 0 0]};
lst = {'-','-.','-','-.','-','-.'};

RAs = {'RR','PF','MX','PF2'};
para.RA = RAs{test_resource_allocation_idx};
UEs = [4 10];
para.UE = UE;
para.ra_ix = test_resource_allocation_idx;
if LARArate == 2,
    para.ra_ix = 4;
end
if MIMO == 2,
    para.ra_ix = 5;
end
para.ue_ix = find(UEs == para.UE);
fileidx = fileidx + 1;
%%
result.ra_idx(fileidx) = test_resource_allocation_idx;
mns = sprintf('%3.2fs',mean(thpt));
result.LGDmn{fileidx} = [para.RA,',UE',num2str(para.UE),',F',num2str(LARArate),',',MIMO,',M:',mns];
%%
cfigure(1);%cfigure(1);
handCDF = cdfplot(thpt);
set(handCDF,'color',colors{fileidx},'linestyle',lst{fileidx},'linewidth',2);hold on;
result.figname{1}=['CDF_of_ue_thpt'];
xlabel('UE Throughput in Mbps','FontSize',14,'fontname','times','FontWeight','b');
ylabel('CDF of UE Throughput','FontSize',14,'fontname','times','FontWeight','b');
savefigs(result.figname{1},[loaddir figdir]);
close all
