% figure 1: CDF of UE alive time
% figure 2: x: distance y: UE alive time
% average UE distance during it's alive time, save the alive time and
% distance as y and x.
% sort by x, average across several UEs, and plot

function [result,fileidx] = res_ue_alive(test_resource_allocation_idx,UE,LARArate,MIMO,loaddir,result,fileidx,av_factor,Comm_conf,figdir)
filename = ['RA',num2str(test_resource_allocation_idx),'_UE',num2str(UE),'_LARA',num2str(LARArate),MIMO,'_trms',num2str(Comm_conf.t_rms),'f',num2str(Comm_conf.fd),'_s',num2str(Comm_conf.state),'N',num2str(Comm_conf.N),'subN',num2str(Comm_conf.subN),'_E',num2str(Comm_conf.flg_csi_err),'c',num2str(Comm_conf.flg_offset),'D',num2str(Comm_conf.DELAY),'BO',num2str(Comm_conf.BO_dB),'HPA',num2str(Comm_conf.use_HPA_flg),'_BLER',num2str(Comm_conf.targetFER),'.mat'];
load([loaddir,'/',filename],'save_user_mobID','save_user_distance');
colors = {[0.5 0.5 0.5],[0 0 0],[0 0.5 1],[0 0 1],[1 0 0.5],[1 0 0]};
%colors = {'k','k','b','b','r','r'};
lst = {'-','-.','-','-.','-','-.'};

RAs = {'RR','PF','MX','PF2'};
para.RA = RAs{test_resource_allocation_idx};
UEs = [4 10];
para.UE = UE;
para.ra_ix = test_resource_allocation_idx;
if LARArate == 2,
    para.ra_ix = 4;
end
if MIMO == 2,
    para.ra_ix = 5;
end
para.ue_ix = find(UEs == para.UE);
para.nuSymbol = 6;
para.subN = 12;
para.Tfrm = 5e-4;


fileidx = fileidx + 1;
%%
result.ra_idx(fileidx) = test_resource_allocation_idx;
%%
load([loaddir,'/',filename],'save_user_mobID','save_user_distance');
mobID = reshape(save_user_mobID',[],1);
mobDist = reshape(save_user_distance',[],1);

for lp_nmob = 1:max(mobID)
    interest_idx = find(mobID == lp_nmob);
    alive(lp_nmob) = length(interest_idx);
    dist(lp_nmob) = mean(double(mobDist(interest_idx)));
end

[dist_sort,idx] = sort(dist);
alive_sort = alive(idx);
mns = sprintf('%3.2f',mean(alive)*5e-4);
result.LGD{fileidx} = [para.RA,',UE',num2str(para.UE),',F',num2str(LARArate),',',MIMO];
result.LGDmn{fileidx} = [para.RA,',UE',num2str(para.UE),',F',num2str(LARArate),',',MIMO,',M:',mns];

cfigure(1);%cfigure(1);
handCDF = cdfplot(alive * 5e-4);hold on;
set(handCDF,'color',colors{fileidx},'linestyle',lst{fileidx},'linewidth',2);
result.figname{1}='CDF_of_ue_aliveTime';
xlabel('UE Alive Time in Second','FontSize',14,'fontname','times','FontWeight','b');
ylabel('CDF of UE Alive Time','FontSize',14,'fontname','times','FontWeight','b');
savefigs(result.figname{1},[loaddir figdir]);

cfigure(2);%cfigure(2);
plot(average2(double(dist_sort),av_factor),5e-4 * average2(double(alive_sort),av_factor),'color',colors{fileidx},'linestyle',lst{fileidx},'linewidth',2);hold on;
result.figname{2}=['ue_aliveTime','_vs_dist'];
xlabel('Distance in Meter','FontSize',14,'fontname','times','FontWeight','b');
ylabel('UE Alive Time in Second','FontSize',14,'fontname','times','FontWeight','b');
savefigs(result.figname{2},[loaddir figdir]);
close all