% figure 1: x: distance, y: SINR (averaged)
% figure 2: CDF of SINR per block
function [result,fileidx] = res_ue_sinr(test_resource_allocation_idx,UE,LARArate,MIMO,loaddir,result,fileidx,av_factor,Comm_conf,figdir)
filename = ['RA',num2str(test_resource_allocation_idx),'_UE',num2str(UE),'_LARA',num2str(LARArate),MIMO,'_trms',num2str(Comm_conf.t_rms),'f',num2str(Comm_conf.fd),'_s',num2str(Comm_conf.state),'N',num2str(Comm_conf.N),'subN',num2str(Comm_conf.subN),'_E',num2str(Comm_conf.flg_csi_err),'c',num2str(Comm_conf.flg_offset),'D',num2str(Comm_conf.DELAY),'BO',num2str(Comm_conf.BO_dB),'HPA',num2str(Comm_conf.use_HPA_flg),'_BLER',num2str(Comm_conf.targetFER),'.mat'];
load([loaddir,'/',filename],'save_user_sinr','save_user_distance');
colors = {[0.5 0.5 0.5],[0 0 0],[0 0.5 1],[0 0 1],[1 0 0.5],[1 0 0]};
lst = {'-','-.','-','-.','-','-.'};

RAs = {'RR','PF','MX','PF2'};
para.RA = RAs{test_resource_allocation_idx};
UEs = [4 10];
para.UE = UE;
para.ra_ix = test_resource_allocation_idx;
if LARArate == 2,
    para.ra_ix = 4;
end
if MIMO == 2,
    para.ra_ix = 5;
end
para.ue_ix = find(UEs == para.UE);
para.nuSymbol = 6;
para.subN = 12;
para.Tfrm = 5e-4;
fileidx = fileidx + 1;
%%
result.ra_idx(fileidx) = test_resource_allocation_idx;
result.LGD{fileidx} = [para.RA,',UE',num2str(para.UE),',F',num2str(LARArate),',',MIMO];
%%
fig_ix = 0;
dist = reshape(save_user_distance,[],1);
[dist_sort,idx] = sort(dist);
tmp2 = 10.^(double(save_user_sinr)/10);
%clear save*
tmp3 = mean(tmp2,3);
yy=reshape(tmp3,[],1);
sinr_sort = yy(idx);

fig_ix = fig_ix + 1;
cfigure(fig_ix);%cfigure(fig_ix);
plot(average2(double(dist_sort),av_factor),10*log10(average2(double(sinr_sort),av_factor)),'color',colors{fileidx},'linestyle',lst{fileidx},'linewidth',2);hold on;
result.figname{fig_ix}='ue_sinr_vs_dist';
xlabel('Distance in Meter','FontSize',14,'fontname','times','FontWeight','b');
ylabel('Averaged SINR at UE in dB','FontSize',14,'fontname','times','FontWeight','b');
savefigs(result.figname{fig_ix},[loaddir figdir]);

fig_ix = fig_ix + 1;
cfigure(fig_ix);%cfigure(fig_ix);
close(fig_ix)

%intval = 100;

%save_user_sinr = save_user_sinr(:,1:size(save_user_sinr,2)/4,:);
%[y,x] = cdfcalc(double(save_user_sinr(:)));
%handCDF = plot(x(1:end),y(2:end));hold on;
handCDF = cdfplot(save_user_sinr(:));
set(handCDF,'color',colors{fileidx},'linestyle',lst{fileidx},'linewidth',2);
result.figname{fig_ix}='CDF_of_ue_sinr';
xlabel('SINR per Block at UE in dB','FontSize',14,'fontname','times','FontWeight','b');
ylabel('CDF of SINR','FontSize',14,'fontname','times','FontWeight','b');
savefigs(result.figname{fig_ix},[loaddir figdir]);
close all
