% Function: channelgenerator2
%The multipath channel matrix generator
%Using rayleighchan function in MATLAB
%chnums is the number of channel realizations
%fd is the Doppler frequency
%divn is the number of diversity branches
%t_rms is the delay spread in us
%The output is matrix ch, for channel impulse response
%clear all;close all;
%clc;
function ch = channelgenerator2(t_rms,fd,sampling_rate,N,cp_l,BW,chnums,divn)
if t_rms==0 && fd ==0,
    ch = ones(1,chnums,divn);
end
Ch=raych2(chnums*divn,fd,t_rms,sampling_rate,N,cp_l,BW);
for i=1:divn
    ch(:,:,i)=Ch(:,(i-1)*chnums+1:i*chnums);
    %save (sprintf('ch%d',i),'ch');
end
