% Function : BT_alamouti
% Alamouti-STBC scheme for MISO-Alamouti
%return if not MISO system
%T_mod is the modulated signal
%Nsymbol is the No. of symbols within each frame
%state can be 1,2,3,4 or 5, indicates different systems (1=SISO,2=MRC,3=MISO,4=EGC,5=AS)
%
%by Yuanye Wang
%29-06-2006
function T_trans=BT_alamouti(T_mod,Nsymbol,state)
% if state~=3
%     T_trans=T_mod;
%     return;
% end
if state == 3 || state == 6
    for k=1:2:Nsymbol
        Ant0(:,k:k+1) = [T_mod(:,k) -conj(T_mod(:,k+1))];    
        Ant1(:,k:k+1) = [T_mod(:,k+1) conj(T_mod(:,k))];        
    end
    T_trans(:,:,1)=Ant0;T_trans(:,:,2)=Ant1;
else
    T_trans = T_mod;
end
    