% Function : N_encoder
% parameters: code_rate,raw_bits,lens
%           raw_bits are the bits to be encoded
%           lens is the total length of coded bits that is necessary to
%           fill the block
% Function: Does convolution encoding of the raw bits at the code rate
% given and then adds zeros if necessary
function [coded,t,real_len] = N_encoder(code_rate,raw_bits,lens)
if code_rate==1||code_rate==0
    coded=raw_bits;t=[];
elseif code_rate==1/2
    t = poly2trellis(7,[171 133]); % Define trellis.
    code = convenc(raw_bits,t); % Length is 2*len.
    coded=code; %rate 1/2
elseif code_rate==1/3    % % Puncture by removing every third value.
    t = poly2trellis(7,[171 165 133]); % Define trellis.
    code = convenc(raw_bits,t); % Length is 2*len.
    coded=code; %rate 1/2
elseif code_rate==2/3 
    t = poly2trellis(7,[171 133]); % Define trellis.
    punctcode = convenc(raw_bits,t); % Length is (2*len)*2/3.;
    punctcode(4:4:end)=[]; % Length is (2*len)*2/3.
    coded=punctcode;
end
real_len = length(coded);
if real_len < lens;
    coded(end+1:lens) = zeros(1,lens-real_len);
end
