% Function Rapps_model
%%%%%%%%%%%%%%%%% Generate amplifier model, using p=3 %%%%%%%%%%%%%%%%
% x_in : signal input, can be complex signal
% Flg  : '' implies exponent value of 2 is used in the SSPA model, if 'Ideal' is
% specified , the exponent value of 1e3 is used in the SSPA high power amplifier
% model
% x_out: output signal include phase

function x_out=Rapps_model(x_in,Flg)

%a=0:0.2:2;
switch(Flg)
    case 'Ideal'
        p=1e3;
    otherwise 
        p=2;%2.5;
end
% RealPin=real(P_in); % Seperating real part of the signal.
% AmpR=(RealPin./(((1+RealPin.^(2*p))).^(1/(2*p)))); % Amplification of the real part according to Rapps model.
% ImgPin=imag(P_in);% Seperating imaginary part of the signal.
% AmpI=(ImgPin./(((1+ImgPin.^(2*p))).^(1/(2*p)))); % Amplification of the imaginary part according to Rapps model.
%  
% P_amp=AmpR+i*AmpI;%Adding up this two signal to get back the amlified signal




phi=atan2(imag(x_in),real(x_in));
Ampli_x_in=abs(x_in);
x_out=exp(j*phi).*(Ampli_x_in./(((1+Ampli_x_in.^(2*p))).^(1/(2*p)))); % Amplification according to Rapps model.