% This function is used to find threshold needed for Adaptive modulation
% and coding. This function calls func_findthres which contains the details
% algorithm for finding the threshold.
%

function [ts,POST_SNR_bin_centers,blk_err_c_rate] = find_thres(TS_conf,M,cdrt,misnr,mxsnr,stp,Root_path)
%
if nargin == 2,
    misnr = 0; % min SNR
    mxsnr = 30;% Max SNR
    stp = 1;% Step through in the SNR
elseif nargin == 4,
    stp = 1;
end
%
[ts,ber_u,ber_c,fer_u,fer_c,se_u,se_c,...
    POST_SNR_bin_centers,blk_err_c_rate,bit_err_c_rate] = ...
    func_findthres(TS_conf.state,TS_conf.fd,TS_conf.t_rms,TS_conf.subN,TS_conf.F_LA,TS_conf.Nframe,cdrt,M,...
    misnr,stp,mxsnr,TS_conf.targetFER,...
    TS_conf.Ptotal,TS_conf.BO_dB,TS_conf.use_HPA_flg,...
    TS_conf.chnums,TS_conf.sampling_rate,TS_conf.flg_offset,TS_conf.flg_csi_err,...
    TS_conf.N,TS_conf.cp_l,TS_conf.BW,TS_conf.Nsymbol,TS_conf.dirname,TS_conf.allow_load_oldres,Root_path);