% this function will analyse results from non-adapted systems to 
% find the threshold,throughput for a certain target, given
% the discrete ber/fer/throughput vs SNR vectors
% this threshold will be put into the threshold tables and used later in
% adapted systems
% By Yuanye Wang
% CTIF,AAU
% yywang@kom.aau.dk

function [mg]=func_res5(fer_c,misnr,stp,targetFER)
lin_stp = 100;
ix = 0;
for tgt = targetFER
    ix = ix + 1;
    a = find(fer_c>tgt);
    if length(a)==0||a(end)==length(fer_c)%length(a)==length(fer_c)
        mg(ix)=NaN;
    else
        tmp_FER = linspace(fer_c(a(end)),fer_c(a(end)+1),lin_stp);
        abs_mg = abs(tmp_FER - tgt);
        [v,p] = min(abs_mg);
        mg(ix) = misnr+(length(a)-1)*stp+(p-1)*stp/length(tmp_FER);
    end
end