% Function : qmodulator2
% parameters: x,M
%   x is the bit sequence input and M is the modulation level
% functional description: The function find the modulation level, loads the
% appropriate table for modulation map and then maps input bit stream to
% the modulation map and generates the modulated symbols


function  yqam=qmodulator2(x,M)
K=log2(M);                              %x must be even(use the function randint to generate the bits
res=rem(length(x),K);                   %Remainder after division(exact number of bits)
if (res ~= 0)
    x=x(1:length(x)-res);
end
symbi=reshape(x,K,length(x)/K).';        %Reshape in matrix containg column vectors for each symbol in Binary
symdec=bi2de(symbi,'left-msb');          %Converting from binary to Decimal
z=symdec;
%clear yqmod;
switch M
    case 2
        load qam2;
    case 4
        load qam4;
    case 8
        load qam8;
    case 16
        load qam16;
    case 32
        load qam32;
    case 64
        load qam64;
    case 128
        load qam128;
    case 256
        load qam256;
end
for i=1:length(z)
    q(i)=yqmod(z(i)+1);
end
yqam=q;
