% Function : selectAntenna2
% Parameters : the frequency domain channel coefficeints H, FFT size N, 
% numbers of subcarriers in the group subN, state indicates the kind of MIMO scheme which is described earlier
% The transmit diversity order is given in T_div
% Depending upon the MIMO case, it generates the combined channel
% coefficients, i.e in case of anatenna selection it choses the channel
% coefficients which have been used
function [H_comb,H_LA,ps]=selectAntenna2(H,N,subN,state,T_div)
if state == 5 || state == 7
    H1 = squeeze(H(:,1,:));
    g = abs(H1).^2;
    for k=1:floor(N/subN)
        g_subN(k,:)=mean(g((k-1)*subN+1:k*subN,:),1);
    end
    for tx = 1:T_div
        g_tp(:,tx) = sum(g_subN(:,tx:T_div:end),2);
    end
    [temp,ps]=max(g_tp,[],2);
    %H_old = H(:,DELAY+1:end,:);
    for k = 1:floor(N/subN)
        H_comb((k-1)*subN+1:k*subN,:,:) = H((k-1)*subN+1:k*subN,:,ps(k):T_div:end);
        H_LA((k-1)*subN+1:k*subN,:) = squeeze(H((k-1)*subN+1:k*subN,1,ps(k):T_div:end));
    end
else
    %H_comb = H(:,DELAY+1:end,:); ps = [];
    H_comb = H; ps = [];
    H_LA = squeeze(H(:,1,:));
end

