% function : comm_config 
% Common configuration for both link-level and system-level simulator
% The parameters used here are derived from previous value. This procedure
% is used because separate link and system level simulator were integrated
% using a common set of variables.
% suvra.das@gmail.com
% yy, 01-july-2007
function Comm_conf = ...
    comm_config(fd,t_rms,F_LA,F_PA,BO_dB,use_HPA_flg,flg_offset,flg_csi_err,BW,cf,N,subN,cp_l,Nsymbol,state,targetFER,chnums,sampling_rate,DELAY,Ts,Tf)
Comm_conf.fd = fd;
Comm_conf.t_rms = t_rms;
Comm_conf.F_LA = F_LA;
Comm_conf.F_PA = F_PA;
Comm_conf.BO_dB = BO_dB;
Comm_conf.use_HPA_flg = use_HPA_flg;
Comm_conf.flg_offset = flg_offset;
Comm_conf.flg_csi_err = flg_csi_err;
Comm_conf.N = N;
Comm_conf.subN = subN;
Comm_conf.cp_l = cp_l;
Comm_conf.BW = BW;
Comm_conf.cf = cf;
Comm_conf.Nsymbol = Nsymbol;
Comm_conf.state = state;
Comm_conf.targetFER = targetFER;
Comm_conf.Ptotal = 1;
Comm_conf.chnums = chnums;
Comm_conf.sampling_rate = sampling_rate;
Comm_conf.DELAY = DELAY;
Comm_conf.Ts = Ts;
Comm_conf.Tf = Tf;
%state can be 1,2,3,4,5,6,7 indicates different systems
%(1=SISO,2=MRC1x2,3=ALT2x1,4=EGC1x2,5=AS2x1,6=ALT2x2,7=AS2x2)
T_div = [1 1 2 1 2 2 2];
R_div = [1 2 1 2 1 2 2];
Comm_conf.T_div = T_div(Comm_conf.state);
Comm_conf.R_div = R_div(Comm_conf.state);
Comm_conf.divn = Comm_conf.T_div * Comm_conf.R_div;
