% Function func_sys_lv_simu
% Iteratively calls the mainOFDMA function which is the main system level
% simulator for different test scenarios {'micro1','macro1','macro3'}; %
% Cell configurations etc as well as
% for different possible resource allocation algorithms and finally
% different drops that is different realizations of the shadow fading.
% system-level simulator
%
% yy, 01-july-2007
function func_sys_lv_simu(test_possible_user_numbers,test_possible_user_velocities,scenario_ix,RA_ix,Root_path,st_initConfig,Comm_conf,a,b)
if nargin == 8,
    a = 1;
% % % %     b = 6;
b = 2;
end
test_possible_scenarios = {'micro1','macro1','macro3'}; % Cell configurations
                            % micro cell case 1, macro cell case1, macro
                            % cell case 3. These correspond to the
                            % different test conditions as given in the
                            % 3GPP LTE specs
test_possible_resource_allocations = {'RR','PF','MAXCI','PF2'}; % Resource allocation algorithms
                            % RR indicates Round Robin, 
                            % PF indicates Proportional Fair
                            % MAXCI indicates max C/I
                            % PF2 indiactes proportional fair type2.
test_scenario = test_possible_scenarios{scenario_ix};
test_resource_allocation  = test_possible_resource_allocations{RA_ix}
for lp_nu_drops=a:b
    for test_avg_velo_kmph = test_possible_user_velocities
        for test_nu_active_users = test_possible_user_numbers  
            tic
            mainOFDMA(test_avg_velo_kmph,test_nu_active_users,test_scenario,test_resource_allocation,lp_nu_drops,st_initConfig,Comm_conf,Root_path);
            toc
        end
    end
end
