
%__________________________________________________________________________
% Type:                 :   File Header
% File name             :   initialize_baseStation
% File Description      :   contains the function to initialize base
%                           stations
%__________________________________________________________________________
%  
%__________________________________________________________________________
% Type:                 :   Function Header
% Function name         :   initialize_baseStation
% input                 :   st_initConfig
% output                :   st_baseStation: structure of base station,
%                           which contains several parameters like the
%                           location (loc), directivity (fib)
%                       :   rombvec : coverage area
% calling functions     :   input_config
% called functions      :   CRECELL,
% Function Description  :   Initailizes the base station structure
%__________________________________________________________________________
%  
%  
function [st_initConfig] = initialize_base_station(st_initConfig)
% Calling the CRECELLS function from RUNE simulator to create cells
   
[st_initConfig.locBS,st_initConfig.fib,st_initConfig.rombvec]=crecells(st_initConfig.cellRadius,st_initConfig.sps,st_initConfig.km,st_initConfig.lm,st_initConfig.nuCluster);

st_initConfig.rombvec       = st_initConfig.scaleFactor*[st_initConfig.cellRadius*exp(-j*pi/4) st_initConfig.cellRadius*exp(j*pi/4)];%1.75*[st_initConfig.cellRadius*exp(-j*pi/4) st_initConfig.cellRadius*exp(j*pi/4)];

switch st_initConfig.scenarioLabel
   case 'micro1'
       st_initConfig.centerBsLoc   = mean(st_initConfig.rombvec); % Centre location for the base station
   otherwise
       st_initConfig.centerBsLoc   = mean(st_initConfig.rombvec)-st_initConfig.cellRadius;
end  


%st_initConfig.centerBsLoc   = mean(st_initConfig.rombvec)-st_initConfig.cellRadius;
