%__________________________________________________________________________
% Type:                 :   File Header
% File name             :   initialize_mobileStation
% File Description      :   contains the function to initialize mobile
%                           stations
%__________________________________________________________________________
%
%__________________________________________________________________________
% Type:                 :   Function Header
% Function name         :   initialize_mobileStation
% input                 :   st_initConfig
% output                :   st_mobileStation: structure of mobile station,
%                           which contains several parameters like 
%                       :   
% calling functions     :   inputConfig
% called functions      :   MOBMOVE,
% Function Description  :   Initialize the mobile station
%__________________________________________________________________________

function [st_initConfig,st_mobileStations] = initialize_mobile_station(st_initConfig)

%-------------------------
% Create Mobiles
%-------------------------
[st_initConfig.locMS,st_initConfig.veloMS]=...
    mobmoveScale(st_initConfig.locMS,st_initConfig.veloMS,st_initConfig.aMean,st_initConfig.vMean,...
    st_initConfig.dT,st_initConfig.rombvec,st_initConfig.centerBsLoc,st_initConfig.locBS(st_initConfig.desiredBsIdx),st_initConfig.dmin);


for lp_nmob = 1:st_initConfig.nuMob % this portion has to be changed to accommodate
                                    % the new model where a user is
                                    % dies after its quota of data is
                                    % finished and a new user is born in
                                    % the system. Therefore each user must
                                    % have a different index number and the
                                    % number of frame it will live depends
                                    % on the channel conditions.
    st_mobileStations(lp_nmob).MobNumber(1:st_initConfig.nuFrmPerSlot) = 0; % Mobile identification number
    st_mobileStations(lp_nmob).RemFileSz(1:st_initConfig.nuFrmPerSlot) = 0; % Remaining file size to be trasmitted to the mobile    
end
