%__________________________________________________________________________
% Type:                 :   File Header
% File name             :   main
% File Description      :   Instructions / function calls to run the
%                           simulator. It will call the functions input,
%                           the simulator engine, and the measurement unit
%                           version 3: This contains code to simulate
%                           and compare cases. The
%                           comparison will be in terms of throughput Vs
%                           Distance, as a function of number of users in
%                           the system under round robin scheduling with
%                           equal number of sub carriers allocated to each
%                           user. 
%__________________________________________________________________________

function mainOFDMA(test_avg_velo_kmph,test_nu_active_users,test_scenario,test_resource_allocation,lp_nu_drops,st_initConfig,Comm_conf,Root_path)
%-----------------------------
% Prepare for simulation
%-----------------------------
%close all open files handlers
%fclose('all');
tic % tic to begin clock, and toc to end clock
% set the random number generators to a random (real random taking the clock state) state
rand('state',sum(100*clock));
randn('state',sum(100*clock));
%-----------------------------
% Read Input settings
%-----------------------------
% SchedulingAlgoChoiceNumber=4;%4;%2; % Which scheduling algorithm to be used.
% See the config file, it is called from the
% input_config
% 2 for RR
% 4 for max C/I
% 5 for simple PF
% set figures to display curves

% CALL THE INPUT CONFIG FUNCTION, SO THAT THE VARIABLES ARE INITIALIZED
[st_initConfig, st_baseStation,st_measurement,st_channelGrid,st_mobileStations] = input_config(test_avg_velo_kmph,test_nu_active_users,test_scenario,test_resource_allocation,st_initConfig,Comm_conf,Root_path);

%make directory for the test case defined above to store the result
test_case_name=[Root_path,'/sys_link_result/sys_lv_result/',st_initConfig.test_case_name,'Drp',num2str(lp_nu_drops),'_trms',num2str(Comm_conf.t_rms),'f',num2str(Comm_conf.fd),'_s',num2str(Comm_conf.state),'N',num2str(Comm_conf.N),'subN',num2str(Comm_conf.subN),'_E',num2str(Comm_conf.flg_csi_err),'c',num2str(Comm_conf.flg_offset),'D',num2str(Comm_conf.DELAY),'BO',num2str(Comm_conf.BO_dB),'HPA',num2str(Comm_conf.use_HPA_flg),'_BLER',num2str(Comm_conf.targetFER)];
if ~exist(test_case_name,'dir'),mkdir(test_case_name);end;
%change over to the directory to save the results
cd(test_case_name);
%-----------------------------
% Call the main simulator engine
%-----------------------------
st_initConfig = ofdma_sfn_Cellular_la_dl_simulator(st_channelGrid, st_initConfig,st_baseStation,st_measurement,st_mobileStations);
save dataSimConfig	st_initConfig
% just to measure the time taken to simulate (this is not at all important)
total_time_sec = toc; total_time_min = total_time_sec/60
cd(Root_path)
