%__________________________________________________________________________
% Type:                 :   Function Header
% Function name         :   ofdma_sfn_Cellular_la_dl_simulator
% input                 :   st_channelGrid,st_initConfig,st_mobileStations,st_baseStations
% output                :   st_channelGrid,st_initConfig,st_mobileStations,st_baseStations
%                       :
% calling functions     :   input_config
% called functions      :
% Function Description  : 
%                       :   contains the function to simulate OFDMA signle
%                           frequency cellular link adapted downlink
%                           simulator

%__________________________________________________________________________
function st_initConfig = ofdma_sfn_Cellular_la_dl_simulator(st_channelGrid, st_initConfig,st_baseStation,st_measurement,st_mobileStations)

cnt_meas=0; % counter for measurement module
% For as many frames as required
% figure(1);plothex(st_initConfig.locBS,st_initConfig.fib);
% title('Cell Layout')

MobileIdCnt =0;%counter for mobile identifier number
warning('off','all')

% pre-allocate the user-info to be saved.
user_velocity = uint8(zeros(st_initConfig.nuMob,st_initConfig.saveUserInfo_factor));
user_distance = uint16(zeros(st_initConfig.nuMob,st_initConfig.saveUserInfo_factor));
user_ActiveCnt = uint16(zeros(st_initConfig.nuMob,st_initConfig.saveUserInfo_factor));
user_sinr = int8(zeros(st_initConfig.nuMob,st_initConfig.saveUserInfo_factor,st_baseStation.nuSubChannels));
user_sinr_noFeedBackErr = int8(zeros(st_initConfig.nuMob,st_initConfig.saveUserInfo_factor,st_baseStation.nuSubChannels));
user_mobID = uint16(zeros(st_initConfig.nuMob,st_initConfig.saveUserInfo_factor));
user_fair = (zeros(st_initConfig.nuMob,st_initConfig.saveUserInfo_factor));
for lp_nFrames=1:st_initConfig.nusubFrames % This has to be changed to run for number fo seconds
    % where users die and are born
    % until the simulation time is over

    %INCLUDE ONE MORE LEVEL OF LOGIC, WHERE USERS ARE GENERATED ONLY AT
    %THE 2/5/10/20 MS BOARDER


    % This assumes that for the 2 ms frame , one user gets the same set of
    % sub carriers continuously. i.e. there is no Time Frequency
    % scheduling. Only Frequency domain scheduling.

    % THIS HAS TO CHANGE LATER ON TO PER 0.5 MS, SO THAT TIME FREQUENCY
    % SCHEDULING CAN BE VERIFIED. THIS CAN BE DONE VERY EASILY BY JUST
    % CHANGING THE DEFINITION OF 'st_initConfig.nuOfdmSymbPerFrame' IN THE
    % TEST CONFIG FILE , AS OF NOW THERE IS NO 2 MS, ALL ARE 0.5 MS .

    % WHEN THAT CHANGE WILL BE DONE, THEN THE SCHEDULER HAS TO BE UPDATED
    % SO THAT A MATRIX IS MADE WHICH IS HAVING TIME FREQUENCY DIMENSION,
    % WHERE MOBILE INDEXS WILL BE STORED WHICH WILL IDENTIFY THE TIME
    % FREQUENCY RESOURCE TO BE ALLOCATED TO THE MOBILE. THIS INFORMATION
    % HAS TO BE UPDATED EVERY 2/5/10/20 MS, WHERE AS THIS MATRIX SHOULD BE
    % READ EVERY 0.5 MS FOR SUB CARRIER ALLOCATION



    st_initConfig.nFrmCnt=lp_nFrames;
    st_initConfig.nFrmCntSlot=mod(lp_nFrames-1,st_initConfig.nuFrmPerSlot)+1;
    save_UserInfor_times = ceil(lp_nFrames/st_initConfig.saveUserInfo_factor); % how many times has been saved
    save_UserInforCnt = mod(lp_nFrames-1,st_initConfig.saveUserInfo_factor) + 1;

    % as of now this function will create a random drop of users this will be
    % changed very soon where users who have finished trasmitting will quit the
    % system while new users will join
    switch st_initConfig.measure_g_factorFlg
        case 'yes'
            % do not use the frequency selective fading and do not consider
            % handover
            need correction
            [st_channelGrid,st_initConfig,st_mobileStations,MobileIdCnt,st_baseStation,st_measurement]=update_mobile_structres_before_frame_g_fac_no_fsf(st_initConfig,st_channelGrid,st_mobileStations,MobileIdCnt,st_baseStation,st_measurement);
            switch st_initConfig.handOffFlg
                case 'handoff'
                    need correction
                    [cnt_meas,st_measurement,st_mobileStations] = measurementGfactor(cnt_meas,st_channelGrid,st_measurement,st_baseStation,st_mobileStations,st_initConfig);
                case 'nofsfnohandoff'
                    need correction
                    [cnt_meas,st_measurement,st_mobileStations] = measurementGfactorNoHandOff(cnt_meas,st_channelGrid,st_measurement,st_baseStation,st_mobileStations,st_initConfig);
            end
        case 'no'
            % use frequency selective fading

            % as of now this function will create a random drop of users and update
            % user locations and users who have finished trasmitting will quit the
            % system while new users will join
            [st_channelGrid,st_initConfig,st_mobileStations,MobileIdCnt,st_baseStation,st_measurement]= update_mobile_structres_before_frame2(st_initConfig,st_channelGrid,st_mobileStations,MobileIdCnt,st_baseStation,st_measurement);

            %-----------------------------
            % Get Feedback and adjust for feedback delay
            %-----------------------------
            % There can be several factors for feedback, for example
            % average SINR, in each sub band (for sub carrier allocation)
            % average rms delay spread and average Doppler Condition
            % only average path loss parameter
            % As of now, since the first version will include only random sub
            % carrier allocation, therefore there is no need to feedback detailed
            % CSI.

            % 1. Measure the SINR per sub channel of each mobile
            % 2. Store in each mobile station structure
            [st_mobileStations,st_channelGrid] = measureMobileSinr2(st_initConfig,st_baseStation,st_channelGrid,st_mobileStations);
            %end
            if mod(st_initConfig.nFrmCnt-1,st_initConfig.F_LA)==0
                %-----------------------------
                % CALL LINK ADAPTATION ALGORITHM THEN
                % CALL SCHEDULING ALGORITHM : THESE ARE FOR TESTING LA PERFORMANCE
                %-----------------------------
                % Store the suitable rate, per mobile, per sub carrier, considering
                % 1. power adaptation is not done
                % 2.
                % scheduler will take this information and allocate only a few resource
                % units to one user, though the user measures the performance of all
                % resource units
                [st_baseStation,st_mobileStations,st_measurement] = link_adaptation(st_initConfig,st_baseStation,st_channelGrid,st_mobileStations,st_measurement);
                %-----------------------------
                % allocates resources (time frequency chunks) to users
                % TO call the RA block only once per FRAME, which is the unit
                % for AMC, though power control can be done at a faster rate
                [st_baseStation] = resource_alloc(st_baseStation, st_mobileStations, st_initConfig);
                % OR
                % CALL JOINT LINK ADAPTATION + SCHEDULING ALGORITHM: THIS IS THE NEW
                % ALGORITHMS THAT ARE TO COME OUT
            elseif mod(st_initConfig.nFrmCnt-1,st_initConfig.F_PA)==0
                % power control algorithm function call
                % and its relationship with respect to the sub frame duration
                % and the power control loop update rate
                for subn_idx = 1:st_baseStation.nuSubChannels
                    %save yytmp subn_idx st_baseStation st_mobileStations
                    %keyboard
                    new_SINR_dB(subn_idx) = int8(round(10*log10(st_mobileStations(st_baseStation.allocation(subn_idx)).sinrFeedBack(subn_idx))));
                    %st_baseStation.poweradjust;
                    %new_SINR_dB = int8(round(10*log10(new_SINR)));
                    old_SINR_dB(subn_idx) = user_sinr(st_baseStation.allocation(subn_idx),mod(lp_nFrames-1 - st_initConfig.F_PA,st_initConfig.saveUserInfo_factor)+1,subn_idx);
                end
                P_inc = find(and(new_SINR_dB<old_SINR_dB,st_baseStation.poweradjust'~=0)==1);
                P_dec = find(and(new_SINR_dB>old_SINR_dB,st_baseStation.poweradjust'~=0)==1);
                st_baseStation.poweradjust(P_dec) = st_baseStation.poweradjust(P_dec) * (1 - 1/5);
                P_av = st_baseStation.nuSubChannels - sum(st_baseStation.poweradjust);
                P_need = sum(st_baseStation.poweradjust(P_inc)) * 1/5; 
                if P_need <= P_av,
                    st_baseStation.poweradjust(P_inc) = st_baseStation.poweradjust(P_inc) * (1 + 1/5); 
                else 
                    rat_fac = P_av/P_need; st_baseStation.poweradjust(P_inc) = st_baseStation.poweradjust(P_inc) * (1 + 1/5 * rat_fac); 
                end
            end
            %-------------------------------
            %-------------------------------
            % Do the power allocation. and put flags between the resource
            % allocation and the power allocation based on the frame period

            %-------------------------------
            %-------------------------------


            %lp_nFrames
            %if mod(st_initConfig.nFrmCnt-1,st_initConfig.FrameToSubTimeFrameRatio)==0
            %st_initConfig.saveUserInfo_factor = 100; % save user information per 100 subframes
            %save_UserInforCnt = mod(lp_nFrames-1,st_initConfig.saveUserInfo_factor) + 1;
            %save yytmp;
            for lp_nmob=1:st_initConfig.nuMob
                user_velocity(lp_nmob,save_UserInforCnt) = uint8(round(abs(st_initConfig.veloMS(lp_nmob))));
                user_distance(lp_nmob,save_UserInforCnt) = uint16(round(abs(st_initConfig.locMS(lp_nmob) - st_initConfig.locBS(st_initConfig.desiredBsIdx))));
                % this sinr is when no power adjustment is done
                user_sinr(lp_nmob,save_UserInforCnt,:) = int8(round(10*log10(st_mobileStations(lp_nmob).sinrFeedBack)));
                user_sinr_noFeedBackErr(lp_nmob,save_UserInforCnt,:) = int8(round(10*log10(st_mobileStations(lp_nmob).sinrFeedBackNoChErr)));
                user_mobID(lp_nmob,save_UserInforCnt) = uint16(st_mobileStations(lp_nmob).MobNumber(st_initConfig.nFrmCntSlot));
                user_ActiveCnt(lp_nmob,save_UserInforCnt) = uint16(st_mobileStations(lp_nmob).MobActiveCnt);
                user_fair(lp_nmob,save_UserInforCnt) = st_mobileStations(lp_nmob).fair;
            end
            %save_UserInfor_times = ceil(lp_nFrames/st_initConfig.saveUserInfo_factor); % how many times has been saved
            if save_UserInforCnt == st_initConfig.saveUserInfo_factor
                subdirname = 'user_gain_info_and_distance';
                if ~exist(subdirname,'dir'),mkdir(subdirname);end;
                save([subdirname,'/','saveIndex',num2str(save_UserInfor_times)],'user_velocity','user_distance','user_sinr','user_sinr_noFeedBackErr','user_mobID','user_ActiveCnt','user_fair');
            end

            % store the snr feedback and the current SNR
            % this is in the base station part
            for lp_nuSubChannels=1:st_baseStation.nuSubChannels
                st_measurement.snrFeedBackNoChErr(lp_nuSubChannels,save_UserInforCnt)=int8(round(10*log10(st_mobileStations(st_baseStation.allocation(lp_nuSubChannels,1,1)).sinrFeedBackNoChErr(lp_nuSubChannels))));
                % store the snr feedback and the current SNR with Error
                st_measurement.snrFeedBack(lp_nuSubChannels,save_UserInforCnt)=int8(round(10*log10(st_mobileStations(st_baseStation.allocation(lp_nuSubChannels,1,1)).sinrFeedBack(lp_nuSubChannels))));
            end
            %------------------------------
            % Store the allocation information for saving
            % and later analysis
            %-----------------------------

            %-----------------------------
            % fill all channel values for all ofdm symbols
            %-----------------------------
            % This can be done in the measurement unit, one mobile, one link at a
            % time and the history then cleared to have minimum memory requirements



            %CALL FUNCTION TO STORE THE CHANNEL COEFFS TO BE USED FOR LINK
            %ADAPTATIO. UPDATE THE CHANNEL OBJECT BELONGING TO THE MOBILE AT THE
            %SAME TIME. ALSO UPDATE REQUIRED PARAMETERS

            %-----------------------------
            % CALL THE MEASUREMENT FUNCTION
            %-----------------------------

            %%measure the SINR for all sub carriers, i.e measure the sinr for each
            %%sub carrier set (sub channel), therefore it considers path loss plus shadowing plus
            %%frequency selective fading
            [cnt_meas,st_measurement,st_mobileStations] = measurement2(cnt_meas,st_channelGrid,st_measurement,st_baseStation,st_mobileStations,st_initConfig);

            %save_UserInfor_times = ceil(lp_nFrames/st_initConfig.saveUserInfo_factor); % how many times has been saved




            for lp_nmob=1:st_initConfig.nuMob
                st_measurement.ThptAvgPast(lp_nmob,save_UserInforCnt)=st_mobileStations(lp_nmob).ThptAvgPast;
                st_measurement.Thpt(lp_nmob,save_UserInforCnt)=st_mobileStations(lp_nmob).Thpt;
                st_measurement.remFileSzStore(lp_nmob,save_UserInforCnt)=int32(round(st_mobileStations(lp_nmob).RemFileSz(mod(st_initConfig.nFrmCntSlot,st_initConfig.nuFrmPerSlot)+1)));
            end
            for lp_nuSubChannels=1:st_baseStation.nuSubChannels
                % the value of the modulation used, use unit8
                st_measurement.modStore(lp_nuSubChannels,save_UserInforCnt)=uint8(st_baseStation.mod(lp_nuSubChannels,1,1));
                st_measurement.poweradjust(lp_nuSubChannels,save_UserInforCnt) = st_baseStation.poweradjust((lp_nuSubChannels),1,1);
                % the value of the fec used, use double
                st_measurement.fecStore(lp_nuSubChannels,save_UserInforCnt)=int8(round(10*st_baseStation.fec(lp_nuSubChannels,1,1)));
                % the value of the mobile idx, which is the identification of a
                % particular mobile and not the handle
                st_measurement.mobIdxStore(lp_nuSubChannels,save_UserInforCnt)=uint16(st_baseStation.mobId(lp_nuSubChannels,1,1));
                % store the distance between the mobile and the base station
                st_measurement.distanceStore(lp_nuSubChannels,save_UserInforCnt)=uint16(ceil((st_baseStation.ueDistance(lp_nuSubChannels,1,1))));
                % store the snr the current SNR
                st_measurement.snrAfterAMC(lp_nuSubChannels,save_UserInforCnt)=int8(round(10*log10(st_mobileStations(st_baseStation.allocation(lp_nuSubChannels,1,1)).sinrFeedBack(lp_nuSubChannels))));
                % store the snr the current SNR
                st_measurement.snrAfterAMCNoChErr(lp_nuSubChannels,save_UserInforCnt)=int8(round(10*log10(st_mobileStations(st_baseStation.allocation(lp_nuSubChannels,1,1)).sinrFeedBackNoChErr(lp_nuSubChannels))));


                %remaining file size. a -ve value indicates completed
                %transmission

            end
    end

    st_measurement.instThpt(save_UserInforCnt)=(st_measurement.totalBitsSent)/(st_initConfig.nFrmCnt*st_initConfig.subFramePeriod);
    if save_UserInforCnt == st_initConfig.saveUserInfo_factor
        subdirname = 'measurement';
        if ~exist(subdirname,'dir'),mkdir(subdirname);end;
        save([subdirname,'/','dataVals',num2str(save_UserInfor_times)],'st_measurement');
    end
    if mod(lp_nFrames,50)==0
        ['Frm No.=' num2str(st_initConfig.nFrmCnt) ' Nu Usrs=' num2str(MobileIdCnt) ' out=' num2str(st_measurement.outageCnt)  ' T=' num2str((st_initConfig.nFrmCnt)*st_initConfig.subFramePeriod) 's' ]

        ['bps/Hz=' num2str(st_measurement.instThpt(save_UserInforCnt)/st_initConfig.bw) '  Mbps=' num2str(st_measurement.instThpt(save_UserInforCnt)/(1024*1024)) ' KB=' num2str(round(st_measurement.totalBitsSent)/(8*1024))]
    end
    % INCREASE THE TIMER BY THE TIME EQUAL TO THE SUB FRAME DURATION
    st_initConfig.currTimeinSec=st_initConfig.currTimeinSec+st_initConfig.subFramePeriod;
end % end of loop for number for frames
